#!/usr/bin/env ruby

dbsize = 500000
nprocs = 500
aborts = nprocs/10

db = PStore.new("/tmp/foo")
ls = []
dbsize.times {|n| ls << n}
db.transaction {|d| d["ls"] = ls}


procs = []
nprocs.times do
  procs << Process.fork do
    cdb = PStore.new("/tmp/foo")
    cdb.transaction do
      |d|
      ls = d["ls"]
      ls[0] += 1
    end
  end
end

aborts.times {|i| Process.kill("SIGKILL", procs[i*10]) rescue nil}
nprocs.times {Process.wait}
db.transaction {|d| p d["ls"][0]}
